diff -ruN ../nakedmudv3.2.1/lib/pymodules/account_handler.py lib/pymodules/account_handler.py
--- ../nakedmudv3.2.1/lib/pymodules/account_handler.py	1969-12-31 19:00:00.000000000 -0500
+++ lib/pymodules/account_handler.py	2006-12-24 22:31:26.000000000 -0500
@@ -0,0 +1,284 @@
+'''
+account_handler.py
+
+The login and creation of accounts, and handles all account procedures, loading
+and deleting, of characters.
+'''
+import mud, mudsys, char, hooks, account, socket, event, telnetlib
+
+# control sequences for squelching passwords
+squelch   = telnetlib.IAC + telnetlib.WILL + telnetlib.ECHO
+unsquelch = telnetlib.IAC + telnetlib.WONT + telnetlib.ECHO
+
+
+
+def check_acct_name(name):
+    '''Makes sure an account name is valid'''
+    return (len(name) > 3 and len(name) < 13 and
+            name[0].isalpha() and name.isalnum())
+
+def acct_name_prompt(sock):
+    sock.send_raw("What is your account name? ")
+
+def acct_new_password_prompt(sock):
+    sock.send_raw("What is your new password? " + squelch)
+
+def acct_password_prompt(sock):
+    sock.send_raw("What is your password? " + squelch)
+
+def acct_confirm_password_prompt(sock):
+    sock.send_raw("\r\nVerify your password? " + squelch)
+
+def acct_wait_dns_prompt(sock):
+    sock.send_raw("Resolving your internet address, have patience... ")
+
+def acct_finish_prompt(sock):
+    sock.send_raw("{c\r\n*** Press enter to finish account creation:{n ") 
+
+def acct_finish_handler(sock, arg):
+    # pop our input handler for finishing account generation
+    sock.pop_ih()
+
+    # log that the account created
+    mud.log_string("New account '" + sock.account.name + "' has created.")
+
+    # register and save the account to disk
+    mudsys.do_register(sock.account)
+
+def acct_wait_dns_handler(sock, arg):
+    # do nothing
+    return
+
+def acct_name_handler(sock, arg):
+    '''the first prompt a socket encounters; enter a name of an account or
+       a new name of an account to create one'''
+    if mudsys.account_exists(arg):
+        # logging on to an already existing account
+        mud.log_string("Account '" + arg + "' is trying to connect.")
+        acct = mudsys.load_account(arg)
+
+        # attach our account to our socket. Put in mudsys to prevent scripts
+        # from messing around with account and socket connections
+        mudsys.attach_account_socket(acct, sock)
+        sock.pop_ih()
+        sock.push_ih(acct_menu_handler, acct_main_menu)
+        sock.push_ih(acct_password_handler, acct_password_prompt)
+
+    elif not check_acct_name(arg):
+        sock.send(mud.format_string("That is an invalid account name. Your " \
+                                    "account name must only consist of " \
+                                    "characters and numbers, and it must be " \
+                                    "4 and 12 characters in length. The first "\
+                                    "character MUST be a letter. Please pick "\
+                                    "another.", False))
+
+    elif mudsys.account_creating(arg):
+        sock.send("An account with that name is already creating.")
+
+    else:
+        # creating a new account
+        mud.log_string("Account '" + arg + "' is trying to create.")
+
+        # create our new account
+        acct = mudsys.create_account(arg)
+        if acct == None:
+            sock.send("Could not create an account with that name.")
+        else:
+            mudsys.attach_account_socket(acct, sock)
+            sock.pop_ih()
+            sock.push_ih(acct_menu_handler, acct_main_menu)
+            sock.push_ih(acct_finish_handler, acct_finish_prompt)
+            sock.push_ih(acct_confirm_password_handler, acct_confirm_password_prompt)
+            sock.push_ih(acct_new_password_handler, acct_new_password_prompt)
+
+
+def acct_new_password_handler(sock, arg):
+    '''asks a new account for a password'''
+    if len(arg) > 0:
+        # put in mudsys to prevent scripts from messing with passwords
+        mudsys.set_password(sock.account, arg)
+        sock.pop_ih()
+
+def acct_confirm_password_handler(sock, arg):
+    '''checks to see if our argument matches our password; if not, we re-enter
+       our old password'''
+    # password functions put in mudsys to prevent scripts from
+    # messing with passwords
+    if not mudsys.password_matches(sock.account, arg):
+        sock.send("Passwords do not match.")
+        sock.pop_ih()
+        sock.push_ih(acct_confirm_password_handler,acct_confirm_password_prompt)
+        sock.push_ih(acct_password_handler, acct_password_prompt)
+    else:
+        # Password matches. Keep it and go down a level
+        sock.send_raw(unsquelch)
+        sock.pop_ih()
+
+def acct_password_handler(sock, arg):
+    '''asks an account to verify its password'''
+    # password functions put in mudsys to prevent scripts from
+    # messing with passwords
+    sock.send_raw(unsquelch)
+    if not mudsys.password_matches(sock.account, arg):
+        sock.send("Incorrect password.")
+        sock.close()
+    else:
+        # password matches, pop our handler and go down a level
+        sock.pop_ih()
+
+def find_reconnect(name):
+    '''searches through the character list for a PC whose name matches the
+       supplied name'''
+    name = name.lower()
+    for ch in char.char_list():
+        if ch.is_pc and name == ch.name.lower():
+            return ch
+    return None
+
+def acct_load_char(sock, arg):
+    '''loads a character attached to the account. Argument supplied must be a
+       numeric value corresponding to the character'''
+    arg = int(arg)
+    if arg >= len(sock.account.characters()) or arg < 0:
+        sock.send("Invalid choice!")
+    else:
+        # get the name
+        name = sock.account.characters()[arg]
+
+        # first, try a reconnect
+        ch = find_reconnect(name)
+
+        # no reconnect? Try loading our character
+        if not ch == None:
+            # swap the sockets
+            old_sock = ch.sock
+
+            # attach and detach put in mudsys to prevent scripts from
+            # messing around with the connections between chars and sockets
+            mudsys.detach_char_socket(ch)
+            mudsys.attach_char_socket(ch, sock)
+            
+            if old_sock != None:
+                old_sock.close()
+            mud.log_string(ch.name + " has reconnected.")
+            ch.send("You take over a body already in use.")
+            sock.push_ih(mudsys.handle_cmd_input, mudsys.show_prompt)
+
+        else:
+            # load our character. Put in mudsys to prevent scripts from using it
+            ch = mudsys.load_char(name)
+            if ch == None:
+                sock.send("The player file for " + name + " is missing.")
+            elif (mudsys.sys_getval("lockdown") != '' and
+                  not ch.isInGroup(mudsys.sys_getval("lockdown"))):
+                sock.send("You are currently locked out of the mud.")
+                mud.extract(ch)
+            else:
+                # attach put in mudsys to prevent scripts from messing with
+                # character and socket links
+                mudsys.attach_char_socket(ch, sock)
+                if mudsys.try_enter_game(ch):
+                    mud.log_string(ch.name + " has entered the game.")
+                    sock.push_ih(mudsys.handle_cmd_input, mudsys.show_prompt)
+                    ch.page(mud.get_motd())
+                    ch.act("look")
+                    hooks.run("enter", hooks.build_info("ch rm", (ch, ch.room)))
+                else:
+                    sock.send("There was a problem entering the game. " + \
+                              "try again later.")
+                    # detach put in mudsys t prevent scripts from messing with
+                    # character and socket links
+                    mudsys.detach_char_socket(ch, sock)
+                    mud.extract(ch)
+
+def acct_menu_handler(sock, arg):
+    '''parses account commands (new character, enter game, quit, etc)'''
+    if len(arg) == 0:
+        return
+    arg = arg[0].upper()
+    if arg.isdigit():
+        acct_load_char(sock, arg)
+    elif arg == 'Q':
+        sock.send("Come back soon!")
+        mudsys.do_save(sock.account)
+        sock.close()
+    elif arg == 'P':
+        sock.push_ih(acct_confirm_password_handler,acct_confirm_password_prompt)
+        sock.push_ih(acct_new_password_handler, acct_new_password_prompt)
+        sock.push_ih(acct_password_handler, acct_password_prompt)
+    elif arg == 'N':
+        hooks.run("create_character", hooks.build_info("sk", (sock,)))
+    else:
+        sock.send("Invalid choice!")
+
+def display_acct_chars(sock):
+    '''shows the socket a prettied list of characters tied to the account it
+       has attached. Prints three names per line.'''
+    num_cols   = 3
+    print_room = (80 - 10*num_cols)/num_cols
+    fmt        = "  {c%2d{g) %-" + str(print_room) + "s"
+
+    sock.send("{w\r\nPlay a Character:")
+    i = 0
+    for ch in sock.account.characters():
+        sock.send_raw(fmt % (i, ch))
+        if i % num_cols == num_cols - 1:
+            sock.send_raw("\r\n")
+        i = i + 1
+
+    if not i % num_cols == 0:
+        sock.send_raw("\r\n")
+
+def acct_main_menu(sock):
+    '''displays the main menu for the account and asks for a command'''
+    if len(sock.account.characters()) > 0:
+        display_acct_chars(sock)
+
+    sock.send("\r\n{wAdditional Options:")
+    sock.send("  {g[{cP{g]assword change")
+    sock.send("  {g[{cN{g]new character\r\n")
+    sock.send_raw("Enter choice, or Q to quit:{n ")
+
+
+
+################################################################################
+# events for blocking action when dns lookup is in progress
+################################################################################
+def dns_check_event(no_owner, unused, info):
+    sock, = hooks.parse_info(info)
+    if sock.can_use:
+        sock.send("Lookup complete.")
+        sock.pop_ih()
+        sock.bust_prompt()
+    else:
+        event.start_event(None, 0.1, dns_check_event, None, info)
+
+
+
+################################################################################
+# account handler hooks
+################################################################################
+def account_handler_hook(info):
+    # put a nonfunctional prompt up while waiting for the DNS to resolve
+    sock, = hooks.parse_info(info)
+    sock.push_ih(acct_name_handler, acct_name_prompt)
+    sock.push_ih(acct_wait_dns_handler, acct_wait_dns_prompt)
+    event.start_event(None, 0.1, dns_check_event, None, info)
+
+def copyover_complete_hook(info):
+    sock, = hooks.parse_info(info)
+    sock.push_ih(acct_menu_handler, acct_main_menu)
+    sock.push_ih(mudsys.handle_cmd_input, mudsys.show_prompt)
+
+
+
+################################################################################
+# loading and unloading the module
+################################################################################
+hooks.add("receive_connection", account_handler_hook)
+hooks.add("copyover_complete",  copyover_complete_hook)
+
+def __unload__():
+    '''removes the hooks for account handling'''
+    hooks.remove("receive_connection", account_handler_hook)
+    hooks.remove("copyover_complete",  copyover_complete_hook)
diff -ruN ../nakedmudv3.2.1/lib/pymodules/char_gen.py lib/pymodules/char_gen.py
--- ../nakedmudv3.2.1/lib/pymodules/char_gen.py	1969-12-31 19:00:00.000000000 -0500
+++ lib/pymodules/char_gen.py	2006-12-24 22:31:26.000000000 -0500
@@ -0,0 +1,119 @@
+'''
+char_gen.py
+
+The basic character generation module. Allows accounts to create new characters
+with basic selection for name, sex, and race.
+'''
+import mudsys, mud, socket, char, hooks
+
+
+
+def check_char_name(arg):
+    '''checks to make sure the character name is valid. Names are valid if they
+       are greater than 2 characters, less than 13, and comprise only alpha
+       characters.'''
+    return len(arg) >= 3 and len(arg) <= 12 and arg.isalpha()
+
+def cg_name_handler(sock, arg):
+    if not check_char_name(arg):
+        sock.send("Illegal name, please pick another.")
+    elif mudsys.player_exists(arg):
+        sock.send("A player with that name already exists.")
+    elif mudsys.player_creating(arg):
+        sock.send("A player is already being created with that name.")
+    else:
+        name = arg[0].upper() + arg[1:]
+        ch = mudsys.create_player(name)
+
+        if ch == None:
+            sock.send("Illegal name, please pick another.")
+        else:
+            mudsys.attach_char_socket(ch, sock)
+            ch.rdesc = ch.name + " is here."
+            sock.pop_ih()
+
+def cg_sex_handler(sock, arg):
+    try:
+        result = {
+            'M' : 'male',
+            'F' : 'female',
+            'N' : 'neutral'
+            }[arg[0].upper()]
+        sock.ch.sex = result
+        sock.pop_ih()
+    except KeyError:
+        sock.send("Invalid sex, try again.")
+
+def cg_race_handler(sock, arg):
+    if not mud.is_race(arg, True):
+        sock.send("Invalid race selection, try again.")
+    else:
+        sock.ch.race = arg
+        sock.pop_ih()
+
+def cg_finish_handler(sock, arg):
+    # pop our input handler for finishing character generation
+    sock.pop_ih()
+
+    # log that the character created
+    mud.log_string("New player: " + sock.ch.name + " has entered the game.")
+
+    # send them the motd
+    sock.ch.page(mud.get_motd())
+
+    # put him in the starting room
+    sock.ch.room = mudsys.sys_getval("start_room")
+    
+    # run the init_player hook
+    hooks.run("init_player", hooks.build_info("ch", (sock.ch,)))
+
+    # register and save him to disk and to an account
+    mudsys.do_register(sock.ch)
+    
+    # attach him to his account and save the accoutn
+    sock.account.add_char(sock.ch)
+    mudsys.do_save(sock.account)
+    
+    # make him look at the room
+    sock.ch.act("look")
+
+    # run our enter hook
+    hooks.run("enter", hooks.build_info("ch rm", (sock.ch, sock.ch.room)))
+
+def cg_name_prompt(sock):
+    sock.send_raw("What is your character's name? ")
+
+def cg_sex_prompt(sock):
+    sock.send_raw("What is your sex (M/F/N)? ")
+
+def cg_race_prompt(sock):
+    sock.send("Available races are: ")
+    sock.send(mud.list_races(True))
+    sock.send_raw("\r\nPlease enter your choice: ")
+
+def cg_finish_prompt(sock):
+    sock.send_raw("{c*** Press enter to finish character generation:{n ")
+
+
+
+################################################################################
+# character generation hooks
+################################################################################
+def char_gen_hook(info):
+    sock, = hooks.parse_info(info)
+    sock.push_ih(mudsys.handle_cmd_input, mudsys.show_prompt)
+    sock.push_ih(cg_finish_handler, cg_finish_prompt)
+    sock.push_ih(cg_race_handler, cg_race_prompt)
+    sock.push_ih(cg_sex_handler, cg_sex_prompt)
+    sock.push_ih(cg_name_handler, cg_name_prompt)
+
+
+
+################################################################################
+# loading and unloading the module
+################################################################################
+hooks.add("create_character", char_gen_hook)
+
+def __unload__():
+    '''removes the hooks for character generation'''
+    hooks.remove("create_character", char_gen_hook)
diff -ruN ../nakedmudv3.2.1/lib/pymodules/cmd_comm.py lib/pymodules/cmd_comm.py
--- ../nakedmudv3.2.1/lib/pymodules/cmd_comm.py	2006-07-09 17:29:16.000000000 -0400
+++ lib/pymodules/cmd_comm.py	2006-12-24 22:31:26.000000000 -0500
@@ -76,7 +76,7 @@
        example:
          say hello, room!'''
     if arg == '':
-        send_to_char(ch, "Say what?")
+        ch.send("Say what?")
     else:
         arg = arg.replace("$", "$$")
         message(ch, None, None, None, False, "to_room",
@@ -115,7 +115,7 @@
          emote does a little dance.
          emote A gunshot sounds, and $n is laying on the ground, dead.'''
     if arg == '':
-        send_to_char(ch, "Emote we must, but emote what?")
+        ch.send("Emote we must, but emote what?")
     else:
         # see if a $n is within the argument ... if there is, let the person
         # put his or her name where it's wanted. Otherwise, tag it onto the
@@ -127,7 +127,7 @@
 def cmd_gemote(ch, cmd, arg):
     '''cmd_gemote is similar to emote, but it sends a global message'''
     if arg == '':
-        send_to_char(ch, "Gemote we must, but gemote what?")
+        ch.send("Gemote we must, but gemote what?")
     else:
         # same as emote, but global
         if arg.find("$n") == -1:
diff -ruN ../nakedmudv3.2.1/lib/pymodules/cmd_misc.py lib/pymodules/cmd_misc.py
--- ../nakedmudv3.2.1/lib/pymodules/cmd_misc.py	2006-07-09 17:29:16.000000000 -0400
+++ lib/pymodules/cmd_misc.py	2006-12-24 22:31:26.000000000 -0500
@@ -20,7 +20,7 @@
 
 def cmd_clear(ch, cmd, arg):
     '''clear the screen'''
-    ch.send("\033[H\033[J")
+    ch.send_raw("\033[H\033[J")
 
 def event_delayed_cmd(ch, filler, cmd):
     '''used to perform delayed commands'''
@@ -29,13 +29,13 @@
 def cmd_delay(ch, cmd, arg):
     '''Perform a command, but delay its execution by a couple seconds'''
     try:
-        secs, to_delay = parse_args(ch, True, cmd, arg, "int string")
+        secs, to_delay = parse_args(ch, True, cmd, arg, "double string")
     except: return
 
     if secs < 1:
         ch.send("You can only delay commands for positive amounts of time.")
     else:
-        ch.send("You delay '%s' for %d seconds" % (to_delay, secs))
+        ch.send("You delay '%s' for %.2f seconds" % (to_delay, secs))
         event.start_event(ch, secs, event_delayed_cmd, None, to_delay)
 
 def cmd_motd(ch, cmd, arg):
diff -ruN ../nakedmudv3.2.1/lib/pymodules/colour.py lib/pymodules/colour.py
--- ../nakedmudv3.2.1/lib/pymodules/colour.py	1969-12-31 19:00:00.000000000 -0500
+++ lib/pymodules/colour.py	2006-12-24 22:31:26.000000000 -0500
@@ -0,0 +1,88 @@
+"""
+colour.py
+
+NakedMud's base colour module. Contains functions for outbound text processing
+to add ASCII colour codes to the text.
+"""
+import mud, mudsock, hooks
+
+
+
+# symbols and values we need for processing colours
+base_colour_marker   = '{'
+colour_start         = '\x1B['
+cDARK                = '0'
+cLIGHT               = '1'
+
+# colour symbols
+c_none    = 'n'
+c_dark    = 'd'
+c_red     = 'r'
+c_green   = 'g'
+c_yellow  = 'y'
+c_blue    = 'b'
+c_magenta = 'p'
+c_cyan    = 'c'
+c_white   = 'w'
+
+# maps of colour symbols to their ASCII number type thing
+base_colours = { c_none    : '0',
+                 c_dark    : '30',  
+                 c_red     : '31',  
+                 c_green   : '32',  
+                 c_yellow  : '33',  
+                 c_blue    : '34',  
+                 c_magenta : '35',  
+                 c_cyan    : '36',  
+                 c_white   : '37' }
+
+
+
+################################################################################
+# colour processing hooks
+################################################################################
+def process_colour_hook(info):
+    sock,  = hooks.parse_info(info)
+    buf    = sock.outbound_text
+    newbuf = []
+
+    # go through our outbound text and process all of the colour codes
+    i = 0
+    while i < len(buf):
+        if buf[i] == base_colour_marker and i + 1 < len(buf):
+            i = i + 1
+            char  = buf[i]
+
+            # upper case is bright, lower case is dark
+            shade = cLIGHT
+            if char == char.lower():
+                shade = cDARK
+
+            # if it's a valid colour code, build it
+            if base_colours.has_key(char.lower()):
+                newbuf.append(colour_start + shade + ';' + \
+                              base_colours[char.lower()] + 'm')
+
+            # if it was an invalid code, ignore it
+            else:
+                newbuf.append(base_colour_marker)
+                if not char == base_colour_marker:
+                    i = i - 1
+
+        else:
+            newbuf.append(buf[i])
+        i = i + 1
+
+    # replace our outbound buffer with the processed text
+    sock.outbound_text = ''.join(newbuf)
+
+
+
+################################################################################
+# initializing and unloading our hooks
+################################################################################
+hooks.add("process_outbound_text", process_colour_hook)
+
+def __unload__():
+    '''detaches our colour module from the game'''
+    hooks.remove("process_outbound_text", process_colour_hook)
diff -ruN ../nakedmudv3.2.1/lib/pymodules/inform.py lib/pymodules/inform.py
--- ../nakedmudv3.2.1/lib/pymodules/inform.py	2006-07-09 17:29:16.000000000 -0400
+++ lib/pymodules/inform.py	2006-12-24 22:31:26.000000000 -0500
@@ -7,7 +7,7 @@
 #
 ################################################################################
 from mud import *
-import utils, char, hooks
+import utils, char, hooks, mudsock
 
 
 
@@ -51,15 +51,21 @@
     buf = "--------------------------------------------------------------------------------\r\n"
 
     # build character info
-    count = len(char.socket_list())
-    for ch in char.socket_list():
-        buf = buf+(" %-16s %-15s %45s "%(ch.name,ch.race,ch.user_groups))+"\r\n"
+    count   = len(mudsock.socket_list())
+    playing = 0
+    for sock in mudsock.socket_list():
+        if not (sock.ch == None or sock.ch.room == None):
+            buf = buf+(" %-16s %-15s %45s "
+                       % (sock.ch.name,sock.ch.race,sock.ch.user_groups))+"\r\n"
+            playing = playing + 1
 
     conn_end = "s"
     if count == 1: conn_end = ""
+    play_end = "s"
+    if playing == 1: play_end = ""
 
     # build our footer
-    buf = buf + "--------------------------------------------------------------------------------\r\n" + (" %d player" % count)  + conn_end + " currently logged in.\r\n" + "--------------------------------------------------------------------------------\r\n"
+    buf = buf + "--------------------------------------------------------------------------------\r\n" + (" %d socket" % count)  + conn_end + " logged in." + (" %d player" % playing) + play_end + " currently playing.\r\n" + "--------------------------------------------------------------------------------\r\n"
     
     return buf
 
diff -ruN ../nakedmudv3.2.1/lib/pymodules/mud_test.py lib/pymodules/mud_test.py
--- ../nakedmudv3.2.1/lib/pymodules/mud_test.py	1969-12-31 19:00:00.000000000 -0500
+++ lib/pymodules/mud_test.py	2006-12-24 22:16:28.000000000 -0500
@@ -0,0 +1,53 @@
+from mudsys import add_cmd
+import auxiliary
+import storage
+
+# Example auxiliary data class. Holds a single string variable that
+# people are allowed to get and set the value of
+class ExampleAux:
+    # Create a new instance of the auxiliary data. If a storage set is supplied,
+    # read our values from that
+    def __init__(self, set = None):
+        if not set:
+            self.val = "abcxyz"
+        else:
+            self.val = set.readString("val")
+
+    # copy the variables in this auxiliary data to another auxiliary data
+    def copyTo(self, to):
+        to.val = self.val
+
+    # create a duplicate of this auxiliary data
+    def copy(self):
+        newVal = ExampleAux()
+        newVal.val = self.val
+        return newVal
+
+    # returns a storage set representation of the auxiliary data
+    def store(self):
+        set = storage.StorageSet()
+        set.storeString("val", self.val)
+        return set
+
+# allows people to peek at the value stored in their ExampleAux data
+def cmd_getaux(ch, cmd, arg):
+    aux = ch.account.getAuxiliary("example_aux")
+    ch.send("The val is " + aux.val)
+
+# allows people to set the value stored in their ExampleAux data
+def cmd_setaux(ch, cmd, arg):
+    aux = ch.account.getAuxiliary("example_aux")
+    aux.val = arg
+    ch.send("val set to " + arg)
+
+# install our auxiliary data on characters when this module is loaded.
+# auxiliary data can also be installed onto rooms and objects. You can install
+# auxiliary data onto more than one type of thing by comma-separating them in
+# the third argument of this method.
+auxiliary.install("example_aux", ExampleAux, "account")
+
+# add in our two commands
+add_cmd("getaux", None, cmd_getaux, "unconscious", "flying", "admin",
+        False, False)
+add_cmd("setaux", None, cmd_setaux, "unconscious", "flying", "admin",
+        False, False)
diff -ruN ../nakedmudv3.2.1/lib/pymodules/universal_newline.py lib/pymodules/universal_newline.py
--- ../nakedmudv3.2.1/lib/pymodules/universal_newline.py	1969-12-31 19:00:00.000000000 -0500
+++ lib/pymodules/universal_newline.py	2006-12-24 22:31:26.000000000 -0500
@@ -0,0 +1,49 @@
+"""
+universal_newline.py
+
+This module makes sure that all newlines are in a universal form (\r\n)
+regardless of how people send them out. \r, \n, \n\r, and \r\n all get
+transformed to \r\n via this module
+"""
+import mud, mudsock, hooks
+
+
+
+################################################################################
+# universal newline hook
+################################################################################
+def universal_newline_hook(info):
+    sock,  = hooks.parse_info(info)
+    buf    = sock.outbound_text
+    newbuf = []
+    cr     = False
+
+    i = 0
+    while i < len(buf):
+        if not (buf[i] == '\r' or buf[i] == '\n'):
+            newbuf.append(buf[i])
+        elif buf[i] == '\r':
+            if len(newbuf) == 0 or not newbuf[-1] == '\n':
+                cr = True
+                newbuf.append(buf[i])
+        else: # buf[i] == '\n':
+            if cr == False:
+                newbuf.append('\r')
+            cr = False
+            newbuf.append(buf[i])
+        i = i + 1
+    if cr == True:
+        newbuf.append('\n')
+
+    sock.outbound_text = ''.join(newbuf)
+
+
+
+################################################################################
+# initializing and unloading our hooks
+################################################################################
+hooks.add("process_outbound_text", universal_newline_hook)
+
+def __unload__():
+    '''detaches our colour module from the game'''
+    hooks.remove("process_outbound_text", universal_newline_hook)
diff -ruN ../nakedmudv3.2.1/lib/pymodules/utils.py lib/pymodules/utils.py
--- ../nakedmudv3.2.1/lib/pymodules/utils.py	2006-07-09 17:29:16.000000000 -0400
+++ lib/pymodules/utils.py	2006-12-24 22:31:26.000000000 -0500
@@ -107,7 +107,7 @@
             # display our item(s)
             if count == 1:
                 ch.send(s_func(thing))
-            elif m_func == None:
+            elif m_func == None or m_func(thing) == "":
                 ch.send("(" + str(count) + ") " + s_func(thing))
             else:
                 ch.send(m_func(thing) % count)
